define(['exports', 'module', '../util/context-to-element', '../util/get-window', '../util/tabindex-value', '../util/platform'], function (exports, module, _utilContextToElement, _utilGetWindow, _utilTabindexValue, _utilPlatform) {
  'use strict';

  function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

  var _contextToElement = _interopRequireDefault(_utilContextToElement);

  var _getWindow = _interopRequireDefault(_utilGetWindow);

  var _tabindexValue = _interopRequireDefault(_utilTabindexValue);

  var _platform = _interopRequireDefault(_utilPlatform);

  function isOnlyTabbableRules() {
    var _ref = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

    var context = _ref.context;

    var element = (0, _contextToElement['default'])({
      message: 'is/only-tabbable requires an argument of type Element',
      resolveDocument: true,
      context: context
    });

    var nodeName = element.nodeName.toLowerCase();
    var tabindex = (0, _tabindexValue['default'])(element);

    if (nodeName === 'label' && _platform['default'].is.GECKO) {
      // Firefox cannot focus, but tab to: label[tabindex=0]
      return tabindex !== null && tabindex >= 0;
    }

    if (nodeName === 'svg' && _platform['default'].is.TRIDENT) {
      return element.getAttribute('focusable') !== 'false';
    }

    var _window = (0, _getWindow['default'])(element);
    if (element instanceof _window.SVGElement) {
      if (nodeName === 'a' && element.hasAttribute('xlink:href')) {
        // any focusable child of <svg> cannot be focused, but tabbed to
        if (_platform['default'].is.GECKO) {
          return true;
        }
        if (_platform['default'].is.TRIDENT) {
          return element.getAttribute('focusable') !== 'false';
        }
      }
      if (_platform['default'].is.TRIDENT) {
        return element.getAttribute('focusable') === 'true';
      }
    }

    return false;
  }

  // bind exceptions to an iterator callback
  isOnlyTabbableRules.except = function () {
    var except = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

    var isOnlyTabbable = function isOnlyTabbable(context) {
      return isOnlyTabbableRules({
        context: context,
        except: except
      });
    };

    isOnlyTabbable.rules = isOnlyTabbableRules;
    return isOnlyTabbable;
  };

  // provide isOnlyTabbable(context) as default iterator callback
  var isOnlyTabbable = isOnlyTabbableRules.except({});
  module.exports = isOnlyTabbable;
});
//# sourceMappingURL=only-tabbable.js.map